Index: /palm/trunk/SOURCE/microphysics.f90
===================================================================
--- /palm/trunk/SOURCE/microphysics.f90	(revision 1360)
+++ /palm/trunk/SOURCE/microphysics.f90	(revision 1361)
@@ -20,5 +20,7 @@
 ! Current revisions:
 ! ------------------
-! 
+! Bugfix in sedimentation_rain: Index corrected.
+! Vectorized version of adjust_cloud added.
+! Little reformatting of the code.
 ! 
 ! Former revisions:
@@ -126,11 +128,23 @@
     SUBROUTINE microphysics_control
 
-       USE arrays_3d
-       USE cloud_parameters
-       USE control_parameters
-       USE grid_variables
-       USE indices
+       USE arrays_3d,                                                          &
+           ONLY:  hyp, nr, pt, pt_init, q, qc, qr, zu
+
+       USE cloud_parameters,                                                   &
+           ONLY:  cp, hyrho, nc_const, pt_d_t, r_d, t_d_pt
+
+       USE control_parameters,                                                 &
+           ONLY:  call_microphysics_at_all_substeps, drizzle, dt_3d, dt_micro, &
+                  g, intermediate_timestep_count,                              &
+                  large_scale_forcing, lsf_surf, precipitation, pt_surface,    &
+                  rho_surface,surface_pressure
+
+       USE indices,                                                            &
+           ONLY:  nzb, nzt
+
        USE kinds
-       USE statistics
+
+       USE statistics,                                                         &
+           ONLY:  weight_pres
 
        IMPLICIT NONE
@@ -139,231 +153,8 @@
        INTEGER(iwp) ::  j                 !:
        INTEGER(iwp) ::  k                 !:
- 
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb_s_inner(j,i)+1, nzt
-
-             ENDDO
-          ENDDO
-       ENDDO
-
-    END SUBROUTINE microphysics_control
-
-    SUBROUTINE adjust_cloud
-
-       USE arrays_3d
-       USE cloud_parameters
-       USE indices
-       USE kinds
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  i                 !:
-       INTEGER(iwp) ::  j                 !:
-       INTEGER(iwp) ::  k                 !:
-
- 
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb_s_inner(j,i)+1, nzt
-
-             ENDDO
-          ENDDO
-       ENDDO
-
-    END SUBROUTINE adjust_cloud
-
-
-    SUBROUTINE autoconversion
-
-       USE arrays_3d
-       USE cloud_parameters
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE kinds
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  i                 !:
-       INTEGER(iwp) ::  j                 !:
-       INTEGER(iwp) ::  k                 !:
-
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb_s_inner(j,i)+1, nzt
-
-             ENDDO
-          ENDDO
-       ENDDO
-
-    END SUBROUTINE autoconversion
-
-
-    SUBROUTINE accretion
-
-       USE arrays_3d
-       USE cloud_parameters
-       USE control_parameters
-       USE indices
-       USE kinds
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  i                 !:
-       INTEGER(iwp) ::  j                 !:
-       INTEGER(iwp) ::  k                 !:
-
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb_s_inner(j,i)+1, nzt
-
-             ENDDO
-          ENDDO
-       ENDDO
-
-    END SUBROUTINE accretion
-
-
-    SUBROUTINE selfcollection_breakup
-
-       USE arrays_3d
-       USE cloud_parameters
-       USE control_parameters
-       USE indices
-       USE kinds
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  i                 !:
-       INTEGER(iwp) ::  j                 !:
-       INTEGER(iwp) ::  k                 !:
-
- 
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb_s_inner(j,i)+1, nzt
-
-             ENDDO
-          ENDDO
-       ENDDO
-
-    END SUBROUTINE selfcollection_breakup
-
-
-    SUBROUTINE evaporation_rain
-
-       USE arrays_3d
-       USE cloud_parameters
-       USE constants
-       USE control_parameters
-       USE indices
-       USE kinds
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  i                 !:
-       INTEGER(iwp) ::  j                 !:
-       INTEGER(iwp) ::  k                 !:
- 
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb_s_inner(j,i)+1, nzt
-
-             ENDDO
-          ENDDO
-       ENDDO
-
-    END SUBROUTINE evaporation_rain
-
-
-    SUBROUTINE sedimentation_cloud
-
-       USE arrays_3d
-       USE cloud_parameters
-       USE constants
-       USE control_parameters
-       USE indices
-       USE kinds
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  i                 !:
-       INTEGER(iwp) ::  j                 !:
-       INTEGER(iwp) ::  k                 !:
- 
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb_s_inner(j,i)+1, nzt
-
-             ENDDO
-          ENDDO
-       ENDDO
-
-    END SUBROUTINE sedimentation_cloud
-
-
-    SUBROUTINE sedimentation_rain
-
-       USE arrays_3d
-       USE cloud_parameters
-       USE constants
-       USE control_parameters
-       USE indices
-       USE kinds
-       USE statistics
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  i                 !:
-       INTEGER(iwp) ::  j                 !:
-       INTEGER(iwp) ::  k                 !:
- 
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb_s_inner(j,i)+1, nzt
-
-             ENDDO
-          ENDDO
-       ENDDO
-
-    END SUBROUTINE sedimentation_rain
-
-
-!------------------------------------------------------------------------------!
-! Call for grid point i,j
-!------------------------------------------------------------------------------!
-
-    SUBROUTINE microphysics_control_ij( i, j )
-
-       USE arrays_3d,                                                          &
-           ONLY:  hyp, nc_1d,  nr, nr_1d, pt, pt_init, pt_1d, q, q_1d, qc,     &
-                  qc_1d, qr, qr_1d, tend_nr, tend_pt, tend_q, tend_qr, zu
-
-       USE cloud_parameters,                                                   &
-           ONLY:  cp, hyrho, nc_const, pt_d_t, r_d, t_d_pt
-
-       USE control_parameters,                                                 &
-           ONLY:  drizzle, dt_3d, dt_micro, g, intermediate_timestep_count,    &
-                  large_scale_forcing, lsf_surf, precipitation, pt_surface,    &
-                  rho_surface,surface_pressure
-
-       USE indices,                                                            &
-           ONLY:  nzb, nzt
-
-       USE kinds
-
-       USE statistics,                                                         &
-           ONLY:  weight_pres
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  i                 !:
-       INTEGER(iwp) ::  j                 !:
-       INTEGER(iwp) ::  k                 !:
 
        REAL(wp)     ::  t_surface         !:
 
-       IF ( large_scale_forcing .AND. lsf_surf ) THEN
+       IF ( large_scale_forcing  .AND.  lsf_surf ) THEN
 !
 !--       Calculate:
@@ -374,5 +165,6 @@
           DO  k = nzb, nzt+1
              hyp(k)    = surface_pressure * 100.0_wp * &
-                         ( (t_surface - g/cp * zu(k)) / t_surface )**(1.0_wp/0.286_wp)
+                         ( ( t_surface - g / cp * zu(k) ) /                    &
+                         t_surface )**(1.0_wp / 0.286_wp)
              pt_d_t(k) = ( 100000.0_wp / hyp(k) )**0.286_wp
              t_d_pt(k) = 1.0_wp / pt_d_t(k)
@@ -384,42 +176,28 @@
        ENDIF
 
-
-       dt_micro = dt_3d * weight_pres(intermediate_timestep_count)
-!
-!--    Adjust unrealistic values
-       IF ( precipitation )  CALL adjust_cloud( i,j ) 
-!
-!--    Use 1-d arrays
-       q_1d(:)  = q(:,j,i)
-       pt_1d(:) = pt(:,j,i)
-       qc_1d(:) = qc(:,j,i)
-       nc_1d(:) = nc_const
-       IF ( precipitation )  THEN
-          qr_1d(:) = qr(:,j,i)
-          nr_1d(:) = nr(:,j,i)
+!
+!--    Compute length of time step 
+       IF ( call_microphysics_at_all_substeps )  THEN
+          dt_micro = dt_3d * weight_pres(intermediate_timestep_count)
+       ELSE
+          dt_micro = dt_3d
        ENDIF
+
 !
 !--    Compute cloud physics
        IF ( precipitation )  THEN
-          CALL autoconversion( i,j )
-          CALL accretion( i,j )
-          CALL selfcollection_breakup( i,j )
-          CALL evaporation_rain( i,j )
-          CALL sedimentation_rain( i,j )
+          CALL adjust_cloud
+          CALL autoconversion
+          CALL accretion
+          CALL selfcollection_breakup
+          CALL evaporation_rain
+          CALL sedimentation_rain
        ENDIF
 
-       IF ( drizzle )  CALL sedimentation_cloud( i,j )
-!
-!--    Derive tendencies
-       tend_q(:,j,i)  = ( q_1d(:) - q(:,j,i) ) / dt_micro
-       tend_pt(:,j,i) = ( pt_1d(:) - pt(:,j,i) ) / dt_micro
-       IF ( precipitation )  THEN
-          tend_qr(:,j,i) = ( qr_1d(:) - qr(:,j,i) ) / dt_micro
-          tend_nr(:,j,i) = ( nr_1d(:) - nr(:,j,i) ) / dt_micro
-       ENDIF
-
-    END SUBROUTINE microphysics_control_ij
-
-    SUBROUTINE adjust_cloud_ij( i, j )
+       IF ( drizzle )  CALL sedimentation_cloud
+
+    END SUBROUTINE microphysics_control
+
+    SUBROUTINE adjust_cloud
 
        USE arrays_3d,                                                          &
@@ -429,6 +207,9 @@
            ONLY:  eps_sb, xrmin, xrmax, hyrho, k_cc, x0
 
+       USE cpulog,                                                             &
+           ONLY:  cpu_log, log_point_s
+
        USE indices,                                                            &
-           ONLY:  nzb, nzb_s_inner, nzt
+           ONLY:  nxl, nxr, nys, nyn, nzb, nzb_s_inner, nzt
 
        USE kinds
@@ -439,50 +220,55 @@
        INTEGER(iwp) ::  j                 !:
        INTEGER(iwp) ::  k                 !:
-!
-!--    Adjust number of raindrops to avoid nonlinear effects in 
-!--    sedimentation and evaporation of rain drops due to too small or
-!--    too big weights of rain drops (Stevens and Seifert, 2008).
-!--    The same procedure is applied to cloud droplets if they are determined
-!--    prognostically.  
-       DO  k = nzb_s_inner(j,i)+1, nzt
-
-          IF ( qr(k,j,i) <= eps_sb )  THEN
-             qr(k,j,i) = 0.0_wp
-             nr(k,j,i) = 0.0_wp
-          ELSE
-!
-!--          Adjust number of raindrops to avoid nonlinear effects in 
-!--          sedimentation and evaporation of rain drops due to too small or
-!--          too big weights of rain drops (Stevens and Seifert, 2008).
-             IF ( nr(k,j,i) * xrmin > qr(k,j,i) * hyrho(k) )  THEN
-                nr(k,j,i) = qr(k,j,i) * hyrho(k) / xrmin
-             ELSEIF ( nr(k,j,i) * xrmax < qr(k,j,i) * hyrho(k) )  THEN
-                nr(k,j,i) = qr(k,j,i) * hyrho(k) / xrmax
-             ENDIF
-
-          ENDIF
-
+
+       CALL cpu_log( log_point_s(54), 'adjust_cloud', 'start' )
+
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_s_inner(j,i)+1, nzt
+                IF ( qr(k,j,i) <= eps_sb )  THEN
+                   qr(k,j,i) = 0.0_wp
+                   nr(k,j,i) = 0.0_wp
+                ELSE
+!
+!--                Adjust number of raindrops to avoid nonlinear effects in 
+!--                sedimentation and evaporation of rain drops due to too small
+!--                or too big weights of rain drops (Stevens and Seifert, 2008).
+                   IF ( nr(k,j,i) * xrmin > qr(k,j,i) * hyrho(k) )  THEN
+                      nr(k,j,i) = qr(k,j,i) * hyrho(k) / xrmin
+                   ELSEIF ( nr(k,j,i) * xrmax < qr(k,j,i) * hyrho(k) )  THEN
+                      nr(k,j,i) = qr(k,j,i) * hyrho(k) / xrmax
+                   ENDIF
+
+                ENDIF
+             ENDDO
+          ENDDO
        ENDDO
 
-    END SUBROUTINE adjust_cloud_ij
-
-
-    SUBROUTINE autoconversion_ij( i, j )
+       CALL cpu_log( log_point_s(54), 'adjust_cloud', 'stop' )
+
+    END SUBROUTINE adjust_cloud
+
+
+    SUBROUTINE autoconversion
 
        USE arrays_3d,                                                          &
-           ONLY:  diss, dzu, nc_1d, nr_1d, qc_1d, qr_1d
+           ONLY:  diss, dzu, nr, qc, qr
 
        USE cloud_parameters,                                                   &
            ONLY:  a_1, a_2, a_3, b_1, b_2, b_3, beta_cc, c_1, c_2, c_3,        &
-                  c_const, dpirho_l, eps_sb, hyrho, k_cc, kin_vis_air, x0
+                  c_const, dpirho_l, eps_sb, hyrho, k_cc, kin_vis_air,         &
+                  nc_const, x0
 
        USE control_parameters,                                                 &
            ONLY:  dt_micro, rho_surface, turbulence
 
+       USE cpulog,                                                             &
+           ONLY:  cpu_log, log_point_s
+
        USE grid_variables,                                                     &
            ONLY:  dx, dy
 
        USE indices,                                                            &
-           ONLY:  nzb, nzb_s_inner, nzt
+           ONLY:  nxl, nxr, nys, nyn, nzb, nzb_s_inner, nzt
 
        USE kinds
@@ -496,5 +282,5 @@
        REAL(wp)     ::  alpha_cc          !:                   
        REAL(wp)     ::  autocon           !:
-       REAL(wp)     ::  epsilon           !:
+       REAL(wp)     ::  dissipation       !:
        REAL(wp)     ::  k_au              !:
        REAL(wp)     ::  l_mix             !:
@@ -509,77 +295,94 @@
        REAL(wp)     ::  xc                !:
 
-       k_au = k_cc / ( 20.0_wp * x0 )
-
-       DO  k = nzb_s_inner(j,i)+1, nzt
-
-          IF ( qc_1d(k) > eps_sb )  THEN
-!
-!--          Intern time scale of coagulation (Seifert and Beheng, 2006):
-!--          (1.0_wp - qc(k,j,i) / ( qc(k,j,i) + qr_1d(k) ))
-             tau_cloud = 1.0_wp - qc_1d(k) / ( qr_1d(k) + qc_1d(k) )
-!
-!--          Universal function for autoconversion process 
-!--          (Seifert and Beheng, 2006):
-             phi_au    = 600.0_wp * tau_cloud**0.68_wp * ( 1.0_wp - tau_cloud**0.68_wp )**3
-!
-!--          Shape parameter of gamma distribution (Geoffroy et al., 2010):
-!--          (Use constant nu_c = 1.0_wp instead?)
-             nu_c      = 1.0_wp !MAX( 0.0_wp, 1580.0_wp * hyrho(k) * qc(k,j,i) - 0.28_wp )
-!
-!--          Mean weight of cloud droplets:
-             xc = hyrho(k) * qc_1d(k) / nc_1d(k)
-!
-!--          Parameterized turbulence effects on autoconversion (Seifert, 
-!--          Nuijens and Stevens, 2010)
-             IF ( turbulence )  THEN
-!
-!--             Weight averaged radius of cloud droplets:
-                rc = 0.5_wp * ( xc * dpirho_l )**( 1.0_wp / 3.0_wp )
-
-                alpha_cc = ( a_1 + a_2 * nu_c ) / ( 1.0_wp + a_3 * nu_c )
-                r_cc     = ( b_1 + b_2 * nu_c ) / ( 1.0_wp + b_3 * nu_c )
-                sigma_cc = ( c_1 + c_2 * nu_c ) / ( 1.0_wp + c_3 * nu_c )
-!
-!--             Mixing length (neglecting distance to ground and stratification)
-                l_mix = ( dx * dy * dzu(k) )**( 1.0_wp / 3.0_wp )
-!
-!--             Limit dissipation rate according to Seifert, Nuijens and 
-!--             Stevens (2010)
-                epsilon = MIN( 0.06_wp, diss(k,j,i) )
-!
-!--             Compute Taylor-microscale Reynolds number:
-                re_lambda = 6.0_wp / 11.0_wp * ( l_mix / c_const )**( 2.0_wp / 3.0_wp ) *  &
-                               SQRT( 15.0_wp / kin_vis_air ) * epsilon**( 1.0_wp / 6.0_wp )
-!
-!--             The factor of 1.0E4 is needed to convert the dissipation rate
-!--             from m2 s-3 to cm2 s-3.
-                k_au = k_au * ( 1.0_wp +                                             &
-                       epsilon * 1.0E4_wp * ( re_lambda * 1.0E-3_wp )**0.25_wp *     &
-                       ( alpha_cc * EXP( -1.0_wp * ( ( rc - r_cc ) /                 &
-                       sigma_cc )**2 ) + beta_cc ) )
-             ENDIF
-!
-!--          Autoconversion rate (Seifert and Beheng, 2006):
-             autocon = k_au * ( nu_c + 2.0_wp ) * ( nu_c + 4.0_wp ) /                &
-                       ( nu_c + 1.0_wp )**2.0_wp * qc_1d(k)**2.0_wp * xc**2.0_wp *   &
-                       ( 1.0_wp + phi_au / ( 1.0_wp - tau_cloud )**2.0_wp ) *        &
-                       rho_surface
-             autocon = MIN( autocon, qc_1d(k) / dt_micro )
-
-             qr_1d(k) = qr_1d(k) + autocon * dt_micro
-             qc_1d(k) = qc_1d(k) - autocon * dt_micro 
-             nr_1d(k) = nr_1d(k) + autocon / x0 * hyrho(k) * dt_micro
-
-          ENDIF
-
+       CALL cpu_log( log_point_s(55), 'autoconversion', 'start' )
+
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_s_inner(j,i)+1, nzt
+
+                IF ( qc(k,j,i) > eps_sb )  THEN
+
+                   k_au = k_cc / ( 20.0_wp * x0 )
+!
+!--                Intern time scale of coagulation (Seifert and Beheng, 2006):
+!--                (1.0_wp - qc(k,j,i) / ( qc(k,j,i) + qr(k,j,i) ))
+                   tau_cloud = 1.0_wp - qc(k,j,i) / ( qr(k,j,i) + qc(k,j,i) )
+!
+!--                Universal function for autoconversion process 
+!--                (Seifert and Beheng, 2006):
+                   phi_au = 600.0_wp * tau_cloud**0.68_wp *                    &
+                            ( 1.0_wp - tau_cloud**0.68_wp )**3
+!
+!--                Shape parameter of gamma distribution (Geoffroy et al., 2010):
+!--                (Use constant nu_c = 1.0_wp instead?)
+                   nu_c = 1.0_wp !MAX( 0.0_wp, 1580.0_wp * hyrho(k) * qc(k,j,i) - 0.28_wp )
+!
+!--                Mean weight of cloud droplets:
+                   xc = hyrho(k) * qc(k,j,i) / nc_const
+!
+!--                Parameterized turbulence effects on autoconversion (Seifert, 
+!--                Nuijens and Stevens, 2010)
+                   IF ( turbulence )  THEN
+!
+!--                   Weight averaged radius of cloud droplets:
+                      rc = 0.5_wp * ( xc * dpirho_l )**( 1.0_wp / 3.0_wp )
+
+                      alpha_cc = ( a_1 + a_2 * nu_c ) / ( 1.0_wp + a_3 * nu_c )
+                      r_cc     = ( b_1 + b_2 * nu_c ) / ( 1.0_wp + b_3 * nu_c )
+                      sigma_cc = ( c_1 + c_2 * nu_c ) / ( 1.0_wp + c_3 * nu_c )
+!
+!--                   Mixing length (neglecting distance to ground and 
+!--                   stratification)
+                      l_mix = ( dx * dy * dzu(k) )**( 1.0_wp / 3.0_wp )
+!
+!--                   Limit dissipation rate according to Seifert, Nuijens and 
+!--                   Stevens (2010)
+                      dissipation = MIN( 0.06_wp, diss(k,j,i) )
+!
+!--                   Compute Taylor-microscale Reynolds number:
+                      re_lambda = 6.0_wp / 11.0_wp *                           &
+                                  ( l_mix / c_const )**( 2.0_wp / 3.0_wp ) *   &
+                                  SQRT( 15.0_wp / kin_vis_air ) *              &
+                                  dissipation**( 1.0_wp / 6.0_wp )
+!
+!--                   The factor of 1.0E4 is needed to convert the dissipation 
+!--                   rate from m2 s-3 to cm2 s-3.
+                      k_au = k_au * ( 1.0_wp +                                 &
+                                      dissipation * 1.0E4_wp *                 &
+                                      ( re_lambda * 1.0E-3_wp )**0.25_wp *     &
+                                      ( alpha_cc * EXP( -1.0_wp * ( ( rc -     &      
+                                                                      r_cc ) / &
+                                                        sigma_cc )**2          &
+                                                      ) + beta_cc              &
+                                      )                                        &
+                                    )
+                   ENDIF
+!
+!--                Autoconversion rate (Seifert and Beheng, 2006):
+                   autocon = k_au * ( nu_c + 2.0_wp ) * ( nu_c + 4.0_wp ) /    &
+                             ( nu_c + 1.0_wp )**2 * qc(k,j,i)**2 * xc**2 *     &
+                             ( 1.0_wp + phi_au / ( 1.0_wp - tau_cloud )**2 ) * &
+                             rho_surface
+                   autocon = MIN( autocon, qc(k,j,i) / dt_micro )
+
+                   qr(k,j,i) = qr(k,j,i) + autocon * dt_micro
+                   qc(k,j,i) = qc(k,j,i) - autocon * dt_micro 
+                   nr(k,j,i) = nr(k,j,i) + autocon / x0 * hyrho(k) * dt_micro
+
+                ENDIF
+
+             ENDDO
+          ENDDO
        ENDDO
 
-    END SUBROUTINE autoconversion_ij
-
-
-    SUBROUTINE accretion_ij( i, j )
+       CALL cpu_log( log_point_s(55), 'autoconversion', 'stop' )
+
+    END SUBROUTINE autoconversion
+
+
+    SUBROUTINE accretion
 
        USE arrays_3d,                                                          &
-           ONLY:  diss, qc_1d, qr_1d
+           ONLY:  diss, qc, qr
 
        USE cloud_parameters,                                                   &
@@ -589,6 +392,9 @@
            ONLY:  dt_micro, rho_surface, turbulence
 
+       USE cpulog,                                                             &
+           ONLY:  cpu_log, log_point_s
+
        USE indices,                                                            &
-           ONLY:  nzb, nzb_s_inner, nzt
+           ONLY:  nxl, nxr, nys, nyn, nzb, nzb_s_inner, nzt
 
        USE kinds
@@ -606,44 +412,54 @@
        REAL(wp)     ::  xc                !:
 
-       DO  k = nzb_s_inner(j,i)+1, nzt
-          IF ( ( qc_1d(k) > eps_sb )  .AND.  ( qr_1d(k) > eps_sb ) )  THEN
-!
-!--          Intern time scale of coagulation (Seifert and Beheng, 2006):
-             tau_cloud = 1.0_wp - qc_1d(k) / ( qc_1d(k) + qr_1d(k) ) 
-!
-!--          Universal function for accretion process 
-!--          (Seifert and Beheng, 2001):
-             phi_ac = tau_cloud / ( tau_cloud + 5.0E-5_wp ) 
-             phi_ac = ( phi_ac**2.0_wp )**2.0_wp
-!
-!--          Parameterized turbulence effects on autoconversion (Seifert, 
-!--          Nuijens and Stevens, 2010). The factor of 1.0E4 is needed to 
-!--          convert the dissipation (diss) from m2 s-3 to cm2 s-3.
-             IF ( turbulence )  THEN
-                k_cr = k_cr0 * ( 1.0_wp + 0.05_wp *                             &
-                                 MIN( 600.0_wp, diss(k,j,i) * 1.0E4_wp )**0.25_wp )
-             ELSE
-                k_cr = k_cr0                       
-             ENDIF
-!
-!--          Accretion rate (Seifert and Beheng, 2006):
-             accr = k_cr * qc_1d(k) * qr_1d(k) * phi_ac *                 &
-                    SQRT( rho_surface * hyrho(k) )
-             accr = MIN( accr, qc_1d(k) / dt_micro )
-
-             qr_1d(k) = qr_1d(k) + accr * dt_micro 
-             qc_1d(k) = qc_1d(k) - accr * dt_micro
-
-          ENDIF
-
+       CALL cpu_log( log_point_s(56), 'accretion', 'start' )
+
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_s_inner(j,i)+1, nzt
+
+                IF ( ( qc(k,j,i) > eps_sb )  .AND.  ( qr(k,j,i) > eps_sb ) )  THEN
+!
+!--                Intern time scale of coagulation (Seifert and Beheng, 2006):
+                   tau_cloud = 1.0_wp - qc(k,j,i) / ( qc(k,j,i) + qr(k,j,i) ) 
+!
+!--                Universal function for accretion process (Seifert and 
+!--                Beheng, 2001):
+                   phi_ac = ( tau_cloud / ( tau_cloud + 5.0E-5_wp ) )**4
+!
+!--                Parameterized turbulence effects on autoconversion (Seifert, 
+!--                Nuijens and Stevens, 2010). The factor of 1.0E4 is needed to 
+!--                convert the dissipation rate (diss) from m2 s-3 to cm2 s-3.
+                   IF ( turbulence )  THEN
+                      k_cr = k_cr0 * ( 1.0_wp + 0.05_wp *                      &
+                                       MIN( 600.0_wp,                          &
+                                            diss(k,j,i) * 1.0E4_wp )**0.25_wp  &
+                                     )
+                   ELSE
+                      k_cr = k_cr0                       
+                   ENDIF
+!
+!--                Accretion rate (Seifert and Beheng, 2006):
+                   accr = k_cr * qc(k,j,i) * qr(k,j,i) * phi_ac *              &
+                          SQRT( rho_surface * hyrho(k) )
+                   accr = MIN( accr, qc(k,j,i) / dt_micro )
+
+                   qr(k,j,i) = qr(k,j,i) + accr * dt_micro 
+                   qc(k,j,i) = qc(k,j,i) - accr * dt_micro
+
+                ENDIF
+
+             ENDDO
+          ENDDO
        ENDDO
 
-    END SUBROUTINE accretion_ij
-
-
-    SUBROUTINE selfcollection_breakup_ij( i, j )
+       CALL cpu_log( log_point_s(56), 'accretion', 'stop' )
+
+    END SUBROUTINE accretion
+
+
+    SUBROUTINE selfcollection_breakup
 
        USE arrays_3d,                                                          &
-           ONLY:  nr_1d, qr_1d
+           ONLY:  nr, qr
 
        USE cloud_parameters,                                                   &
@@ -653,6 +469,9 @@
            ONLY:  dt_micro, rho_surface
 
+       USE cpulog,                                                             &
+           ONLY:  cpu_log, log_point_s
+
        USE indices,                                                            &
-           ONLY:  nzb, nzb_s_inner, nzt
+           ONLY:  nxl, nxr, nys, nyn, nzb, nzb_s_inner, nzt
 
        USE kinds
@@ -669,32 +488,42 @@
        REAL(wp)     ::  selfcoll          !:
 
-       DO  k = nzb_s_inner(j,i)+1, nzt
-          IF ( qr_1d(k) > eps_sb )  THEN
-!
-!--          Selfcollection rate (Seifert and Beheng, 2001):
-             selfcoll = k_rr * nr_1d(k) * qr_1d(k) *         &
-                        SQRT( hyrho(k) * rho_surface )
-!
-!--          Weight averaged diameter of rain drops:
-             dr = ( hyrho(k) * qr_1d(k) / nr_1d(k) * dpirho_l )**( 1.0_wp / 3.0_wp )
-!
-!--          Collisional breakup rate (Seifert, 2008):
-             IF ( dr >= 0.3E-3_wp )  THEN
-                phi_br  = k_br * ( dr - 1.1E-3_wp )
-                breakup = selfcoll * ( phi_br + 1.0_wp )
-             ELSE
-                breakup = 0.0_wp
-             ENDIF
-
-             selfcoll = MAX( breakup - selfcoll, -nr_1d(k) / dt_micro )
-             nr_1d(k) = nr_1d(k) + selfcoll * dt_micro
-
-          ENDIF          
+       CALL cpu_log( log_point_s(57), 'selfcollection', 'start' )
+
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_s_inner(j,i)+1, nzt
+                IF ( qr(k,j,i) > eps_sb )  THEN
+!
+!--                Selfcollection rate (Seifert and Beheng, 2001):
+                   selfcoll = k_rr * nr(k,j,i) * qr(k,j,i) *                   &
+                              SQRT( hyrho(k) * rho_surface )
+!
+!--                Weight averaged diameter of rain drops:
+                   dr = ( hyrho(k) * qr(k,j,i) /                               &
+                          nr(k,j,i) * dpirho_l )**( 1.0_wp / 3.0_wp )
+!
+!--                Collisional breakup rate (Seifert, 2008):
+                   IF ( dr >= 0.3E-3_wp )  THEN
+                      phi_br  = k_br * ( dr - 1.1E-3_wp )
+                      breakup = selfcoll * ( phi_br + 1.0_wp )
+                   ELSE
+                      breakup = 0.0_wp
+                   ENDIF
+
+                   selfcoll = MAX( breakup - selfcoll, -nr(k,j,i) / dt_micro )
+                   nr(k,j,i) = nr(k,j,i) + selfcoll * dt_micro
+
+                ENDIF          
+             ENDDO
+          ENDDO
        ENDDO
 
-    END SUBROUTINE selfcollection_breakup_ij
-
-
-    SUBROUTINE evaporation_rain_ij( i, j )
+       CALL cpu_log( log_point_s(57), 'selfcollection', 'stop' )
+
+    END SUBROUTINE selfcollection_breakup
+
+
+    SUBROUTINE evaporation_rain
+
 !
 !--    Evaporation of precipitable water. Condensation is neglected for 
@@ -702,5 +531,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  hyp, nr_1d, pt_1d, q_1d,  qc_1d, qr_1d
+           ONLY:  hyp, nr, pt, q,  qc, qr
 
        USE cloud_parameters,                                                   &
@@ -716,6 +545,9 @@
            ONLY:  dt_micro
 
+       USE cpulog,                                                             &
+           ONLY:  cpu_log, log_point_s
+
        USE indices,                                                            &
-           ONLY:  nzb, nzb_s_inner, nzt
+           ONLY:  nxl, nxr, nys, nyn, nzb, nzb_s_inner, nzt
 
        USE kinds
